package de.firstdata.ipg.api.client.subsequenttransaction;

import de.firstdata.ipg.api.client.subsequenttransaction.object.ReturnSubsequentTransactionObject;
import de.firstdata.ipg.api.client.subsequenttransaction.object.VoidSubsequentTransactionObject;
import de.firstdata.ipg.api.client.transaction.Amount;

public class IPGApiSubsequentTransactionFactory {

	///////////////////////////// RETURN /////////////////////////////
	/**
	 *
	 * @param amount
	 * @param orderId
	 * @param tDate
	 * @return new ReturnSubsequentTransactionObject(amount, orderId, tDate)
	 */
	public static ReturnSubsequentTransaction createReturnSubsequentTransaction(final Amount amount, final String orderId, final String tDate) {
		return new ReturnSubsequentTransactionObject(amount, orderId, tDate);
	}

	/**
	 *
	 * @param amount
	 * @param ipgTransactionId
	 * @return new ReturnSubsequentTransactionObject(amount, ipgTransactionId)
	 */
	public static ReturnSubsequentTransaction createReturnSubsequentTransaction(final Amount amount, final Long ipgTransactionId) {
		return new ReturnSubsequentTransactionObject(amount, ipgTransactionId);
	}

	/**
	 *
	 * @param amount
	 * @param referencedMerchantTransactionId
	 * @return new ReturnSubsequentTransactionObject(amount,
	 *         referencedMerchantTransactionId)
	 */
	public static ReturnSubsequentTransaction createReturnSubsequentTransaction(final Amount amount, final String referencedMerchantTransactionId) {
		return new ReturnSubsequentTransactionObject(amount, referencedMerchantTransactionId);
	}

	/////////////////////////// VOID /////////////////////////////
	/**
	 *
	 * @param amount
	 * @param orderId
	 * @param tDate
	 * @return new VoidSubsequentTransactionObject(amount, orderId, tDate)
	 */
	public static VoidSubsequentTransaction createVoidSubsequentTransaction(final Amount amount, final String orderId, final String tDate) {
		return new VoidSubsequentTransactionObject(amount, orderId, tDate);
	}

	/**
	 *
	 * @param amount
	 * @param ipgTransactionId
	 * @return new VoidSubsequentTransactionObject(amount, ipgTransactionId)
	 */
	public static VoidSubsequentTransaction createVoidSubsequentTransaction(final Amount amount, final Long ipgTransactionId) {
		return new VoidSubsequentTransactionObject(amount, ipgTransactionId);
	}

	/**
	 *
	 * @param amount
	 * @param referencedMerchantTransactionId
	 * @return new VoidSubsequentTransactionObject(amount,
	 *         referencedMerchantTransactionId)
	 */
	public static VoidSubsequentTransaction createVoidSubsequentTransaction(final Amount amount, final String referencedMerchantTransactionId) {
		return new VoidSubsequentTransactionObject(amount, referencedMerchantTransactionId);
	}
}
