package de.firstdata.ipg.api.client.transaction.creditcard.object;

import de.firstdata.ipg.api.client.IPGApiClient;
import de.firstdata.ipg.api.client.IPGApiResult;
import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.creditcard.CCReturnTransaction;

/**
 * This class represents a <i>Return</i> transaction and allows for setting its
 * optional attributes by calling the appropriate <code>setter</code> methods.
 * An instance of this class is created when calling
 * {@link IPGApiClient#createReturnTransaction(double, String)}.
 * 
 * @author Andreas Schmid
 */
public final class CCReturnTransactionObject extends CCTransactionObject implements CCReturnTransaction {

	/**
	 * creates a <i>Return</i> transaction with the minimum set of parameters -
	 * note that you can add optional fields by calling the appropriate
	 * <code>setter</code> methods on the returned {@link CCReturnTransactionObject}
	 * instance
	 * 
	 * @param orderId
	 *            the order ID this transaction refers to and which is contained
	 *            in an {@link IPGApiResult} instance returned as result to a
	 *            successful {@link CCSaleTransactionObject},
	 *            {@link CCPostAuthTransactionObject}, or
	 *            {@link CCForceTicketTransactionObject} - call
	 *            {@link IPGApiResult#getOrderId()} for accessing this order ID
	 */
	public CCReturnTransactionObject(final Amount amount, final String orderId) {
		super("return", amount, null, null, null, orderId);
	}
}
