package de.firstdata.ipg.api.client.transaction.customercard.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.customercard.CustomerCard;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.CustomerCardData;
import de.firstdata.ipg.api.schema.CustomerCardTxType;

/**
 * <code>IPGApiTransaction</code> is the abstract super class of any other
 * transaction class. It contains methods for setting optional fields which are
 * common to all transactions regardless of their type.
 * 
 * @author Andreas Schmid
 * 
 */
public abstract class CustomerCTransactionObject extends IPGApiTransactionObject {

	protected CustomerCTransactionObject(final String type, final Amount amount, final CustomerCard customerCard, final String orderId) {
		super(amount, null, null, orderId);
		getCustomerCardTxType().setType(type);
		if (customerCard == null) {
			return;
		}
		final CustomerCardData cCD = new CustomerCardData();
		cCD.setCardNumber(customerCard.cardNumber);
		cCD.setExpMonth(customerCard.expMonth);
		cCD.setExpYear(customerCard.expYear);
		setCustomerCardData(cCD);
	}

	@Override
	public void setStoreId(final String storeId) {
		getCustomerCardTxType().setStoreId(storeId);
	}

	@Override
	public String getType() {
		return getCustomerCardTxType().getType();
	}

	@Override
	public CustomerCardTxType getCustomerCardTxType() {
		if (this.customerCardTxType == null) {
			this.customerCardTxType = new CustomerCardTxType();
		}
		return this.customerCardTxType;
	}
}
