package de.firstdata.ipg.api.client.transaction.object;

import de.firstdata.ipg.api.schema.AddressType;
import de.firstdata.ipg.api.schema.MerchantDetails;
import de.firstdata.ipg.api.schema.MerchantMasterData;
import de.firstdata.ipg.api.schema.Terminal;

public class IPGApiMerchantDetailsObject extends MerchantDetails {

	public IPGApiMerchantDetailsObject(final String externalMerchantID, final String alternateExternalMerchantID, final String endpointID,
			final String terminalID) {
		setExternalMerchantID(externalMerchantID);
		setAlternateExternalMerchantID(alternateExternalMerchantID);
		setEndpointID(endpointID);
		setTerminalID(terminalID);
	}

	public void setTerminalID(final String value) {
		getTerminal().setTerminalID(value);
	}

	public void setMCC(final int value) {
		getMerchantMasterData().setMcc(value);
	}

	public void setDBA(final String value) {
		getMerchantMasterData().setDba(value);
	}

	public void setDccEnrollment(final String value) {
		getMerchantMasterData().setDccEnrollment(value);
	}

	public void setDefaultCurrency(final String value) {
		getMerchantMasterData().setDefaultCurrency(value);
	}

	public void setLegalName(final String value) {
		getMerchantMasterData().setLegalName(value);
	}

	public void setEmail(final String value) {
		getMerchantMasterData().setEmail(value);
	}

	public void setTimezone(final String value) {
		getMerchantMasterData().setTimezone(value);
	}

	public void setUrl(final String value) {
		getMerchantMasterData().setUrl(value);
	}

	public void setAddress1(final String value) {
		getAddress().setAddress1(value);
	}

	public void setAddress2(final String value) {
		getAddress().setAddress2(value);
	}

	public void setCity(final String value) {
		getAddress().setCity(value);
	}

	public void setCountry(final String value) {
		getAddress().setCountry(value);
	}

	public void setState(final String value) {
		getAddress().setState(value);
	}

	public void setZip(final String value) {
		getAddress().setZip(value);
	}

	@Override
	public Terminal getTerminal() {
		if (this.terminal == null) {
			this.terminal = new Terminal();
		}
		return this.terminal;
	}

	@Override
	public MerchantMasterData getMerchantMasterData() {
		if (this.merchantMasterData == null) {
			this.merchantMasterData = new MerchantMasterData();
		}
		return this.merchantMasterData;
	}

	public AddressType getAddress() {
		if (getMerchantMasterData().getAddress() == null) {
			getMerchantMasterData().setAddress(new AddressType());
		}
		return getMerchantMasterData().getAddress();
	}
}
