package de.firstdata.ipg.api.client.transaction.sofort.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.SofortTxType;

public abstract class SofortTransactionObject extends IPGApiTransactionObject {

	protected SofortTransactionObject(final String type, final Amount amount, final String orderId) {
		super(amount, null, null, orderId);
		getSofortTxType().setType(type);
	}

	@Override
	public String getType() {
		return getSofortTxType().getType();
	}

	@Override
	public void setStoreId(final String storeId) {
		getSofortTxType().setStoreId(storeId);
	}

	@Override
	public SofortTxType getSofortTxType() {
		if (this.sofortTxType == null) {
			this.sofortTxType = new SofortTxType();
		}
		return this.sofortTxType;
	}
}
