package de.firstdata.ipg.api.client.transaction.wechat.object;

import java.math.BigDecimal;
import java.net.URI;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.wechat.WeChatSaleTransaction;
import de.firstdata.ipg.api.schema.WeChatDomesticInformation;

/**
 * For domestic WeChat sale transactions via ChinaPnR
 */
public class WeChatSaleTransactionObject extends WeChatTransactionObject implements WeChatSaleTransaction {

	private static final String SALE = "sale";

	public WeChatSaleTransactionObject(final Amount amount, final String orderId, final String productCode, final int productQuantity,
			final BigDecimal productPrice, final String productDescription, final URI redirectUrl) {
		super(amount, orderId);
		final WeChatDomesticInformation weChatDomesticInformation = getWeChatDomesticInformation();
		weChatDomesticInformation.setProductCode(productCode);
		weChatDomesticInformation.setProductQuantity(productQuantity);
		weChatDomesticInformation.setProductPrice(productPrice);
		weChatDomesticInformation.setProductDescription(productDescription);
		weChatDomesticInformation.setRedirectUrl(redirectUrl.toString());
	}

	@Override
	public String getType() {
		return SALE;
	}

	@Override
	public WeChatDomesticInformation getWeChatDomesticInformation() {
		if (this.weChatDomesticInformation == null) {
			this.weChatDomesticInformation = new WeChatDomesticInformation();
		}
		return this.weChatDomesticInformation;
	}
}
